#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <errno.h>
#include <time.h>
#include <signal.h>
#include <pwd.h>
#include <getopt.h>
#include <X11/Xlib.h>
#include <libintl.h>
#include <locale.h>
#include "vnctermserv.h"

int isremote=0;
int m=0,all=0;
int remote=0;
/* Default Config*/
int DefaultX=0,DefaultY=0;
int DefaultDepth=16;
char XAUTH[MAXFILE]="xauth";
char VIEWERPROC[MAXFILE]= "xtightvncviewer -geometry +0+0";
char XVNCCMD[MAXFILE]="Xtightvnc -desktop X -pixelformat rgb565 -fp unix/:7100,/usr/lib/X11/fonts/misc,/usr/lib/X11/fonts/75dpi -co /usr/X11R6/lib/X11/rgb -pixelformat rgb565";
char XSESSION[MAXFILE]="/etc/X11/Xsession";
char SSH[MAXFILE]="/usr/bin/ssh";
char INSTPATH[MAXFILE]="vnctermserv";
char REMOTEPARAM[MAXFILE]="-encoding tight";
static char* sname1="default";
static char* sname2="failsafe";
char **Sessions={&sname1,&sname2};
int SessionCount=2;
char* sessionname="default";


struct passwd *pwent;
void readconfig()
{char path[MAXFILE];

readconfigfile("/etc/vnctermserv.cnf");
pwent=getpwuid(getuid());
if(!pwent)return;
sprintf(path,"%s/.vnctermserv/config",pwent->pw_dir);
readconfigfile(path);
}

struct passwd *pwent;
char hn[MAXFILE],pwfile[MAXFILE];
char* locale;






VNCServ* v;


void Startviewer(char*pwfile,int dnr)
{char constr[MAXCMDLINE];FILE*f;int i,sock;
if(remote){
f=NULL;
if(pwfile&&*pwfile)f=fopen(pwfile,"r");
memset(constr,0,sizeof(constr));
if(f){fread(constr,1,8,f);fclose(f);}
write(1,constr,8);
 sock=socketconnect("127.0.0.1",dnr+5900);
 if(sock!=-1)
 copystream(0,1,sock);
 else printf("Error: %s\n",strerror(errno));
return;}
strcpy(constr, VIEWERPROC );
strcat(constr, " ");
if(pwfile&&*pwfile)
{strcat(constr,"-passwd ");
strcat(constr,pwfile);
strcat(constr," ");
}
sprintf(constr+strlen(constr),"127.0.0.1:%d",dnr);
system(constr);
}


void Connect(int ID)
{char constr[MAXCMDLINE],aufile[MAXFILE];
int dnr;int pid;VNCServ *v1;
if(ID==0){
dnr=StartServer(pwent->pw_dir,pwfile,XVNCCMD,XSESSION,sessionname,DefaultDepth,DefaultX,DefaultY);
 Startviewer(pwfile,dnr);
}
else
{ID--;
while(ID>0){v=v->Next;ID--;}
 Startviewer(v->Passwd,v->RFBPort);
}
}

void sshmode(char* id,char*idfile)
{FILE*f;
fd_set r,e;char constr[MAXCMDLINE],buf[MAXCMDLINE];int cod[8];
elist* entry;
char title[MAXFILE];
char* sshargs[20];
int pty;char* a;
int i,lp,cp;int j;char out[2];
char rchar;int rf;
i=forkpty(&pty,0,0,0);
if(i==0){
j=0;
sshargs[j++]=SSH;
sshargs[j++]="-x";
sshargs[j++]="-T";
sshargs[j++]="-enone";
if(idfile){
sshargs[j++]="-i";
sshargs[j++]=idfile;
}
sshargs[j++]=id;
sshargs[j++]=INSTPATH;
sshargs[j++]="-r";
sshargs[j++]="-l";
sshargs[j++]=locale;
if(all)sshargs[j++]="--all";else
if(m)sshargs[j++]="-m";
sshargs[j++]="-d";
sprintf(buf,"%d",DefaultDepth);
sshargs[j++]=buf;
sprintf(constr,"%dx%d",DefaultX,DefaultY);
sshargs[j++]=constr;
sshargs[j++]=0;
dup2(pty,0);
dup2(pty,1);
dup2(pty,2);
execv(SSH,sshargs);
exit(1);
}
rawterm(pty);
lp1:
constr[0]=0;
i=read(pty,constr,sizeof(constr)-200);
if(i==-1||i==0) return;
constr[i]=0;
if(constr[i-2]==':') {
a=gtkgetpass(constr);
if(a)
sprintf(constr,"%s\n",a);
else sprintf(constr,"\n");
write(pty,constr,strlen(constr));
goto lp1;
}else
if(constr[i-2]=='?')
{
i=gtkmsg(constr,0);
if(i==1)
sprintf(constr,"yes\n");
else
sprintf(constr,"no\n");
write(pty,constr,strlen(constr));
read(pty,constr,strlen(constr));
goto lp1;
}
else 
if(strstr(constr,"START_VNCTERMSERV")){}
else
{a=constr;while(*a==' '||*a=='\n'||*a=='\r')a++;
if(*a)gtkmsg(a,2);
goto lp1;}
a=strstr(constr,"START_VNCTERMSERV");
//strcpy(buf,a+18);
unread(a+18,i-(constr-a)-18);

readstring(pty,title,sizeof(title));
i=readint32(pty);
entry=readEntryList(pty,i);

if(i==0&&m==0) {rowselid=0;ConnFlag=1;}
else if(m==0&&i==1){rowselid=1;ConnFlag=1;}
else DoSelect(entry,i,title);

writeint32(pty,rowselid);
writeint32(pty,ConnFlag);
writeint32(pty,DefaultX);
writeint32(pty,DefaultY);
writeint32(pty,DefaultDepth);
writestring(pty,sessionname);

j=0;
while(j<8)
{
i=read(pty,&constr[j],8-j);
if(i==-1||i==0) return;
j+=i;
}


for(i=28000,lp=-1;i<65000&&lp==-1;i++)
lp=CreateListen(i);
if(lp==-1) {gtkmsg(gettext("No Port free"),2);exit(1);}
close(lp);lp=i-1;

sprintf(pwfile,"%s/.vnctermserv/passwd.%d",pwent->pw_dir,getpid());
f=fopen(pwfile,"w");
if(f)fwrite(constr,8,1,f);
if(f)fclose(f);
i=CreateListen(lp);
if(fork()==0)
{close(i);
 close(pty);
sprintf(constr,"%s %s 127.0.0.1::%d -passwd %s",VIEWERPROC,REMOTEPARAM,lp,pwfile);
 printf("Starting:%s\n",constr);
system(constr);
 exit(0);}
i=accept(i,0,0);
printf("Connected\n");
copystream(pty,pty,i);
remove(pwfile);
close(pty);
close(i);
exit(0);
}
elist* buildEntryList(VNCServ*v)
{int c=1;
elist* entrylist;
entrylist=malloc(sizeof(elist)*(CountVnc(v)+1));
strcpy(entrylist[0][0],gettext("New"));
sprintf(entrylist[0][1],gettext("Desktop %dx%d (%d)"),DefaultX,DefaultY,DefaultDepth);
while(v){
sprintf(entrylist[c][0],":%d",v->RFBPort);
sprintf(entrylist[c][1],gettext("Desktop %dx%d (%d)"),v->Width,v->Height,v->Depth);
 v=v->Next;c++;}
 return entrylist;
}
void GetResponse(int* rowselid,int* Conflag)
{*rowselid=readint32(0);
*Conflag=readint32(0);
 DefaultX=readint32(0);
 DefaultY=readint32(0);
 DefaultDepth=readint32(0);
 sessionname=(char*)malloc(MAXFILE+1);
 readstring(0,sessionname,MAXFILE);

}
static struct option long_options[] = {
    {"depth", 1, 0, 0},
    {"help", 0, 0, 0},
    {"prompt", 0, 0, 0},
    {"all", 0, 0, 0},
    {"session", 1, 0, 0},
    {0, 0, 0, 0}
};
int main (int argc, char **argv) 
{
    int  c;
VNCServ**v1,*v2;
Display * d; 
char title[MAXFILE];
int screen;
 int x,y;
elist * entrylist;
char* remid=0;
char* idfid=0;

textdomain("vnctermserv");
readconfig();
 if((argc>1&&strcmp(argv[1],"-r"))||argc==1)
{
 if((d=XOpenDisplay(NULL))!=NULL){
screen=DefaultScreen(d);
if(!DefaultX)DefaultX=DisplayWidth(d,screen);if(!DefaultY)DefaultY=DisplayHeight(d,screen);
XCloseDisplay(d);
}else {
  printf(gettext("No X-Server found\n"));exit(1);
}
gtk_init(&argc, &argv);
}
locale=setlocale(LC_ALL, "" );
while (1) {
    int option_index = 0;

    c = getopt_long (argc, argv, "d:hmru:i:l:",
             long_options, &option_index);
    if (c == -1)
        break;

    switch (c) {
    case 0:
	switch(option_index)
        {
	case 0:
	  goto depth;
	case 1:
	goto help;
	case 2:
	goto menu;break;
	case 3:
	all=1;m=1;break;
	case 4:
	sessionname=optarg;
	}
	break;
    case 'd':
    depth:
	if(!strcmp(optarg,"8"))DefaultDepth=8;else
	if(!strcmp(optarg,"16"))DefaultDepth=16;else
	if(!strcmp(optarg,"32"))DefaultDepth=32;else
	{printf(gettext("Unknown depth: %s\n"),optarg);exit(1);}
        break;
    case 'h':
    help:
	printf(gettext("vnctermserv [--depth 8|16|32] [-m] [--all] [--session sessionname] [-u user@host [-i ssh_id]] [WxH]\n"));
	exit(1);
    case 'm':menu:
	m=1;	
	break;
    case 'r':
      remote=1;
      break;
    case 'l':
      locale=setlocale(LC_ALL,optarg);
      break;
case 'u':
remid=optarg;
break;
case 'i':
idfid=optarg;
break;
    default:
        printf (gettext("Unkonwn option\nTry --help\n"));
	exit(1);
    }
}

if (optind < argc) {
 x=DefaultX;y=DefaultY;
   sscanf(argv[optind++],"%dx%d",&x,&y);
   if(x<100||x>10000)  x=DefaultX;
   if(y<100||y>10000)  y=DefaultY;
DefaultX=x;DefaultY=y;
}
initrand();
v=findvnc(getuid());
if(!all)FreeUsedVnc(&v);
c=CountVnc(v);
hn[0]=0;
gethostname(hn,sizeof(hn)-1);
pwent=getpwuid(getuid());
if(!pwent)return;
sprintf(pwfile,"%s/.vnctermserv/passwd",pwent->pw_dir);
updatepwfile(pwent->pw_dir);
sprintf(title,gettext("VNCSessions %s@%s"),pwent->pw_name,hn);
entrylist=buildEntryList(v);
 if(remote){
SendEntryList(title,c+1,entrylist);
GetResponse(&rowselid,&ConnFlag);
if(ConnFlag==1)Connect(rowselid);
else if(ConnFlag==2)Kill(v,rowselid);exit(0);};
if(remid){sshmode(remid,idfid);exit(0);}
if(c==0&&m==0) Connect(0);
else if(m==0&&v->Width==DefaultX&&v->Height==DefaultY&&v->Next==0)Connect(1);
else {DoSelect(entrylist,c+1,title);
if(ConnFlag==1)Connect(rowselid);
else if(ConnFlag==2)Kill(v,rowselid);};
exit (0);
}


